﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Media;
using System.Windows.Shapes;


namespace TSP
{
    class Tour
    {
        Ort[] orte;
        double gesamtstrecke = -1.0;
        static Random zufall = new Random();
        private Tour()
        { }
        public Tour(List<Ort> orte)
        {
            List<Ort> orte0 = new List<Ort>(orte);

            this.orte = new Ort[orte0.Count];
            for (int i = 0; i < this.orte.Length; i++)
            {
                int z = zufall.Next(orte0.Count);
                this.orte[i] = orte0[z];
                orte0.RemoveAt(z);
            }
        }
        public double berechneGesamtstrecke()
        {
            if (gesamtstrecke < 0.0) // Ist gesamtstrecke noch nicht ausgerechnet?
            {
                double s = 0.0;
                for (int i = 0; i < orte.Length - 1; i++)
                {
                    double deltaX = orte[i+1].X - orte[i].X; 
                    double deltaY = orte[i+1].Y - orte[i].Y; 
                    s += Math.Sqrt(deltaX * deltaX + deltaY * deltaY);
                }
                gesamtstrecke = s;
            }

            return gesamtstrecke;
        }

        public void Zeichne(System.Windows.Controls.Canvas canvas, bool inRot)
        {
            Polyline p = new Polyline();
            p.StrokeMiterLimit = 0.0; // macht die Ecken weniger spitz
            if (inRot)
            {
                p.StrokeThickness = 10.0;
                p.Stroke = new SolidColorBrush(Color.FromArgb(50, 255, 0, 0));
            }
            else
            {
                p.Stroke = new SolidColorBrush(Color.FromArgb(50, 0, 0, 255));
            }
            for (int i = 0; i < orte.Length; i++)
            {
                p.Points.Add(new Point(orte[i].X * canvas.ActualWidth, orte[i].Y * canvas.ActualHeight));
            }
            canvas.Children.Add(p);
        }
        public Tour Mutiere()
        {
            Tour t = new Tour();
            t.orte = (Ort[])orte.Clone();

            int z1 = zufall.Next(t.orte.Length);
            int z2 = zufall.Next(t.orte.Length);

            Ort ort = t.orte[z1];
            t.orte[z1] = t.orte[z2];
            t.orte[z2] = ort;

            return t;
        }
    }
}
